﻿function dockStateChanged() {
    if (System.Gadget.docked) {
		var width = '130px';
		var height = '145px';
	
		$('#background').css('width', width)
						.css('height', height)
						.attr('src', 'images/dockedBg.png');
	
        $(document.body).removeClass('undocked')
						.addClass('docked')
						.css('width', width)
						.css('height', height);
    } else {
		var width = '260px';
		var height = '240px';
		
		$('#background').css('width', width)
						.css('height', height)
						.attr('src', 'images/undockedBg.png');

        $(document.body).removeClass('docked')
						.addClass('undocked')
						.css('width', width)
						.css('height', height);
    }
	
	draw();
}

function onSettingsClosed(e) {
	if (e.closeAction == e.Action.commit) {
        draw();
    }
}

function draw() {
	// в IE эта строка не обязательна, но для ясности
	var background = $('#background').get(0);

	// удаляем фоновые объекты
	background.removeObjects();
	
	// на undocked гаджете помещается побольше объектов
	if(!System.Gadget.docked) {
		// фон		
	}
}


function initSettings() {
    System.Gadget.settingsUI = 'settings.html';
    System.Gadget.onSettingsClosed = onSettingsClosed;

	// устанавливаем значения по умолчанию при первом запуске гаджета	

	var typePlatform = System.Gadget.Settings.readString('typePlatform');
	if(typePlatform == '') {
		System.Gadget.Settings.writeString('typePlatform', 'platform3');
	}
}

function onFlyoutShow() {
	$('#toggle-flyout').text(strings.hideFlyout);
	
	try {
		var fd = System.Gadget.Flyout.document;
		fd.getElementById('header').innerHTML = strings.flyoutHeader;
		
		var flayOutError = System.Gadget.Settings.readString('flayOutError');
		fd.getElementById('description').innerHTML = flayOutError;
	} catch(e) {
	
	}
}


function onFlyoutHide() {
	$('#toggle-flyout').text('');
	System.Gadget.Settings.writeString('flayOutError', '');
}

function initFlyout() {
	System.Gadget.Flyout.file = 'flyout.html';
	System.Gadget.Flyout.onShow = onFlyoutShow;
	System.Gadget.Flyout.onHide = onFlyoutHide;

	$('#toggle-flyout').text('');

	// открываем и закрываем флайаут
	$('#toggle-flyout').get(0).onclick = function() {
		System.Gadget.Flyout.show = !System.Gadget.Flyout.show;
		return false;
	}
}

function ReadyBaseRun()
{
	if (!System.Gadget.Flyout.Show)
	{
		var pathPlatform = System.Gadget.Settings.readString('pathPlatform');
		var pathBase = System.Gadget.Settings.readString('pathBase');
		var errorString = '';
		if (pathPlatform == '')
		{
			errorString = 'Не указан путь запуска платформы';
		}
		if (pathBase == '')
		{
			if (errorString == '')
			{
				errorString = 'Не указан путь к базе данных.';
			}
			else
			{
				errorString = errorString + ' и не указан путь к базе данных.';
			}
		}
	
		if (errorString != '')
		{
			System.Gadget.Settings.writeString('flayOutError', errorString);
			System.Gadget.Flyout.Show = true;
			return false;
		}
	}
	else
	{
		System.Gadget.Flyout.Show = false;
		return false;
	}
	
	return true;
}

function RunBase(mode){
	
	debugger;
	var typePlatform = System.Gadget.Settings.readString('typePlatform');
	var pathPlatform = System.Gadget.Settings.readString('pathPlatform');
	var pathBase = System.Gadget.Settings.readString('pathBase');
	var userName = System.Gadget.Settings.readString('userName');	
	var userPass = System.Gadget.Settings.readString('userPass');

	try
	{
		var WShell = new ActiveXObject("WScript.Shell");
		
		var StringRun = '"' + pathPlatform + '"';
		
		if (mode == 1)
		{
			StringRun = StringRun + ' ENTERPRISE /';
		}
		else
		{
			StringRun = StringRun + ' CONFIG /';
		}

		if (typePlatform == 'platform1')
		{
			StringRun = StringRun + 'D"' + pathBase + '"';
		}
		else
		{
			StringRun = StringRun + 'F"' + pathBase + '"';
		}

		StringRun = StringRun + ' /N"' + userName + '"' + ' /P"' + userPass + '"';
				
		try
		{
			WShell.Run(StringRun, 0, false);
		}
		catch (err)
		{
			System.Gadget.Settings.writeString('flayOutError', 'Ошибка при запуске приложения! Возможно неверные параметры соединения с базой данных.');
			System.Gadget.Flyout.Show = true;
		}

	}
	catch (err)
	{
		System.Gadget.Settings.writeString('flayOutError', 'Невозможно создать объект ActiveX!');
		System.Gadget.Flyout.Show = true;
	}
}


function RunEnterprise(){
	
	// Проверим возможность запуска
	if (ReadyBaseRun()){
		RunBase(1);
	}

}

function RunConfig(){
	
	// Проверим возможность запуска
	if (ReadyBaseRun()){
		RunBase(2);
	}
}


function main() {
	initSettings();
	initFlyout();

	// Задаем имена нашим кнопкам (ссылкам)
	$('#ref-enterprise').text(strings.enterprise);
	$('#ref-config').text(strings.config);

	// Назначаем обработчики событий
	$('#ref-enterprise').get(0).onclick = RunEnterprise;
	$('#ref-config').get(0).onclick = RunConfig;


    System.Gadget.onDock = dockStateChanged;
    System.Gadget.onUndock = dockStateChanged;
    dockStateChanged();
}

$(document).ready(main);